﻿using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using System.Web;
using System.Web.Mvc;
using takvim.v01.Models;

namespace takvim.v01.Controllers
{
    public class HomeController : Controller
    {
        public ActionResult Index(int? id)
        {
            List<SalonViewModel> salonlar = new List<SalonViewModel>();
            List<TesisViewModel> tesisler = new List<TesisViewModel>();
            if (id == null)
            {
                salonlar = new MyContext().Salonlar.Select(x => new SalonViewModel()
                {
                    Ad = x.Ad,
                    TesisID = x.TesisID,
                    EklenmeTarihi = x.EklenmeTarihi,
                    ID = x.ID,
                    Renk = x.Renk
                }).ToList();
                tesisler = new MyContext().Tesisler.Select(x => new TesisViewModel()
                {
                    Ad = x.Ad,
                    EklenmeTarihi = x.EklenmeTarihi,
                    ID = x.ID,
                    Renk = x.Renk
                }).ToList();
            }
            else
            {
                salonlar = new MyContext().Salonlar.Where(x => x.TesisID == id.Value).Select(x => new SalonViewModel()
                {
                    Ad = x.Ad,
                    TesisID = x.TesisID,
                    EklenmeTarihi = x.EklenmeTarihi,
                    ID = x.ID,
                    Renk = x.Renk
                }).ToList();
                tesisler = new MyContext().Tesisler.Where(x => x.ID == id.Value).Select(x => new TesisViewModel()
                {
                    Ad = x.Ad,
                    EklenmeTarihi = x.EklenmeTarihi,
                    ID = x.ID,
                    Renk = x.Renk
                }).ToList();
            }
            ViewBag.tesisler = tesisler;
            ViewBag.salonlar = salonlar;
            List<String> resources = new List<String>();
            resources.Add("Tesisler");
            resources.Add("Salonlar");
            ViewBag.Resources = resources;
            ViewBag.kategoriler = new MyContext().Kategoriler.ToList();
            return View();
        }

        public ActionResult About()
        {
            ViewBag.Message = "Your application description page.";

            return View();
        }

        public ActionResult Contact()
        {
            ViewBag.Message = "Your contact page.";

            return View();
        }
        public JsonResult GetData()
        {
            var data = new MyContext().Rezervasyonlar.ToList(); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
        public JsonResult Batch(EditParams param)
        {
            MyContext db = new MyContext();
            if (param.action == "insert" || (param.action == "batch" && param.added != null))          // this block of code will execute while inserting the appointments
            {
                var value = param.action == "insert" ? param.value : param.added[0];
                int intMax = db.Rezervasyonlar.ToList().Count > 0 ? db.Rezervasyonlar.ToList().Max(p => p.ID) : 1;
                DateTime baslangic = Convert.ToDateTime(value.Baslangic);
                DateTime bitis = Convert.ToDateTime(value.Bitis);
                var currentTimeZone = "UTC +03:00";
                Rezervasyon rez = new Rezervasyon()
                {
                    ID = value.ID,
                    Baslangic = baslangic,
                    Bitis = bitis,
                    BaslangicZamanDilimi = value.BaslangicZamanDilimi,
                    BitisZamanDilimi = value.BitisZamanDilimi,
                    Konu = value.Konu,
                    Aciklama = value.Aciklama,
                    Tekrar = value.Tekrar,
                    TesisID = value.TesisID,
                    SalonID = value.SalonID,
                    KategoriID = value.KategoriID,
                    ButunGunMu = value.ButunGunMu,
                    TekrarKurali = value.TekrarKurali
                };
                db.Rezervasyonlar.Add(rez);
                db.SaveChanges();
            }
            if (param.action == "remove" || param.deleted != null)                                        // this block of code will execute while removing the appointment
            {
                if (param.action == "remove")
                {
                    int key = Convert.ToInt32(param.key);
                    Rezervasyon rez = db.Rezervasyonlar.Where(c => c.ID == key).FirstOrDefault();
                    if (rez != null) db.Rezervasyonlar.Remove(rez);
                }
                else
                {
                    foreach (var rezz in param.deleted)
                    {
                        Rezervasyon rez = db.Rezervasyonlar.Where(c => c.ID == rezz.ID).FirstOrDefault();
                        if (rezz != null) db.Rezervasyonlar.Remove(rez);
                    }
                }
                db.SaveChanges();
            }
            if ((param.action == "batch" && param.changed != null) || param.action == "update")   // this block of code will execute while updating the appointment
            {
                var value = param.action == "update" ? param.value : param.changed[0];
                var filterData = db.Rezervasyonlar.Where(c => c.ID == value.ID);

                if (filterData.Count() > 0)
                {
                    DateTime baslangic = Convert.ToDateTime(value.Baslangic);
                    DateTime endTime = Convert.ToDateTime(value.Bitis);
                    Rezervasyon appoint = db.Rezervasyonlar.Single(A => A.ID == value.ID);
                    appoint.Baslangic = baslangic;
                    appoint.Bitis = endTime;
                    appoint.Konu = value.Konu;
                    appoint.BaslangicZamanDilimi = value.BaslangicZamanDilimi;
                    appoint.BitisZamanDilimi = value.BitisZamanDilimi;
                    appoint.Aciklama = value.Aciklama;
                    appoint.SalonID = value.SalonID;
                    appoint.Tekrar = Convert.ToByte(value.Tekrar);
                    appoint.TesisID = value.TesisID;
                    appoint.ButunGunMu = value.ButunGunMu;
                    appoint.KategoriID = value.KategoriID;
                    appoint.TekrarKurali = value.TekrarKurali;
                }
                db.SaveChanges();
            }
            var data = new MyContext().Rezervasyonlar.ToList(); // nw.Appointment.Take(5);
            return Json(data, JsonRequestBehavior.AllowGet);
        }
    }
}